﻿#include <iostream>
#include <vector>
#include "histogram.h"
#include <algorithm>
#include "text.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>

using namespace std;
struct Input {
    vector<double> numbers;
    size_t bin_count{};
    vector<string> colors;
};

Input
input_data(istream& inn, bool promt) {
    if (promt == true) {
        cerr << "Sovet:" << endl;
    }
    size_t number_count;
    cerr << "Enter number_count: ";
    inn >> number_count;
    Input in;
    cerr << "Enter numbers: ";
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
        inn >> in.numbers[i];
    }
    cerr << "Enter bin_count: ";
    inn >> in.bin_count;
    in.colors.resize(in.bin_count);
    sort(begin(in.numbers), end(in.numbers));
    in.numbers.erase(unique(begin(in.numbers), end(in.numbers)), end(in.numbers));
    number_count = in.numbers.size();
    cerr << "Enter colors: ";
    for (size_t i = 0; i < in.bin_count; i++) {
        inn >> in.colors[i];
    }
    return in;
}


size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    size_t data_size = item_size * item_count;
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    (*buffer).write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input
download(const string& address) {
    stringstream buffer;
    CURL* curl = curl_easy_init();
    if (curl) {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        if (res != CURLE_OK) {
            cerr << curl_easy_strerror(res);
            exit(1);
        }
        curl_easy_cleanup(curl);
    }
    return input_data(buffer, false);
}


int main(int argc, char* argv[]) {
    Input input;
    if (argc > 1) {
        input = download(argv[1]);
    }
    else {
        input = input_data(cin, true);
    }
    const auto bins = make_histogram(input.numbers, input.bin_count);
    show_histogram_svg(bins, input.colors);
}